Index: main/waeup.kofa/branches/henrik-transcript-workflow/src/waeup/kofa/students/viewlets.py
===================================================================
--- main/waeup.kofa/branches/henrik-transcript-workflow/src/waeup/kofa/students/viewlets.py	(revision 15146)
+++ main/waeup.kofa/branches/henrik-transcript-workflow/src/waeup/kofa/students/viewlets.py	(revision 15147)
@@ -391,38 +391,4 @@
 
 
-class StudyCourseTranscriptActionButton(ManageActionButton):
-    grok.order(2)
-    grok.name('transcript')
-    grok.context(IStudentStudyCourse)
-    grok.view(StudyCourseDisplayFormPage)
-    grok.require('waeup.viewTranscript')
-    text = _('Transcript')
-    target = 'transcript'
-    icon = 'actionicon_transcript.png'
-
-    @property
-    def target_url(self):
-        if self.context.student.transcript_enabled:
-            return self.view.url(self.view.context, self.target)
-        return False
-
-
-class TranscriptSlipActionButton(ManageActionButton):
-    grok.order(1)
-    grok.name('transcript_slip')
-    grok.context(IStudentStudyCourse)
-    grok.view(StudyCourseTranscriptPage)
-    grok.require('waeup.viewTranscript')
-    text = _('Academic Transcript')
-    target = 'transcript.pdf'
-    icon = 'actionicon_pdf.png'
-
-    @property
-    def target_url(self):
-        if self.context.student.transcript_enabled:
-            return self.view.url(self.view.context, self.target)
-        return False
-
-
 class RevertTransferActionButton(ManageActionButton):
     grok.order(1)
@@ -760,4 +726,21 @@
 
 
+class StudyCourseTranscriptActionButton(ManageActionButton):
+    grok.order(2)
+    grok.name('transcript')
+    grok.context(IStudentStudyCourse)
+    grok.view(StudyCourseDisplayFormPage)
+    grok.require('waeup.viewTranscript')
+    text = _('Transcript')
+    target = 'transcript'
+    icon = 'actionicon_transcript.png'
+
+    @property
+    def target_url(self):
+        if self.context.student.transcript_enabled:
+            return self.view.url(self.view.context, self.target)
+        return False
+
+
 class RequestTranscriptActionButton(ManageActionButton):
     grok.order(8)
@@ -777,5 +760,5 @@
 
 class ValidateTranscriptActionButton(ManageActionButton):
-    grok.order(9)
+    grok.order(8)
     grok.context(IStudentTranscript)
     grok.view(StudentBaseDisplayFormPage)
@@ -798,6 +781,40 @@
             "You really want to validate the transcript?'")
 
+
+class ReleaseTranscriptActionButton(ManageActionButton):
+    grok.order(8)
+    grok.context(IStudentTranscript)
+    grok.view(StudentBaseDisplayFormPage)
+    grok.require('waeup.processTranscript')
+    text = _('Release transcript')
+    target = 'release_transcript'
+    icon = 'actionicon_transcript.png'
+
+    @property
+    def target_url(self):
+        if self.context.state != TRANSVAL:
+            return ''
+        return self.view.url(self.view.context, self.target)
+
+
+class TranscriptSlipActionButton(ManageActionButton):
+    grok.order(1)
+    grok.name('transcript_slip')
+    grok.context(IStudentStudyCourse)
+    grok.view(StudyCourseTranscriptPage)
+    grok.require('waeup.viewTranscript')
+    text = _('Academic Transcript')
+    target = 'transcript.pdf'
+    icon = 'actionicon_pdf.png'
+
+    @property
+    def target_url(self):
+        if self.context.student.transcript_enabled:
+            return self.view.url(self.view.context, self.target)
+        return False
+
+
 class SignTranscriptActionButton(ManageActionButton):
-    grok.order(9)
+    grok.order(2)
     grok.context(IStudentStudyCourse)
     grok.view(StudyCourseTranscriptPage)
@@ -819,20 +836,4 @@
             "\\n\\n"
             "You really want to sign the transcript?'")
-
-
-class ReleaseTranscriptActionButton(ManageActionButton):
-    grok.order(9)
-    grok.context(IStudentTranscript)
-    grok.view(StudentBaseDisplayFormPage)
-    grok.require('waeup.processTranscript')
-    text = _('Release transcript')
-    target = 'release_transcript'
-    icon = 'actionicon_transcript.png'
-
-    @property
-    def target_url(self):
-        if self.context.state != TRANSVAL:
-            return ''
-        return self.view.url(self.view.context, self.target)
 
 