Index: main/waeup.kofa/branches/henrik-transcript-workflow/CHANGES.txt
===================================================================
--- main/waeup.kofa/branches/henrik-transcript-workflow/CHANGES.txt	(revision 15151)
+++ main/waeup.kofa/branches/henrik-transcript-workflow/CHANGES.txt	(revision 15152)
@@ -4,4 +4,6 @@
 1.6.1.dev0 (unreleased)
 =======================
+
+* Implement new transcript processing workflow.
 
 * Always display applicant payments if they exist.
Index: main/waeup.kofa/branches/henrik-transcript-workflow/docs/source/userdocs/students/workflow.rst
===================================================================
--- main/waeup.kofa/branches/henrik-transcript-workflow/docs/source/userdocs/students/workflow.rst	(revision 15151)
+++ main/waeup.kofa/branches/henrik-transcript-workflow/docs/source/userdocs/students/workflow.rst	(revision 15152)
@@ -47,17 +47,17 @@
                            |              | n                |
                            | j            |                  |
-                           |          graduated              |
-                           |              |                  |
-                           |              | o                |
-                           |              |                  |
-                           |          transcript requested   |
-     a: admit              |              |                  |
-    -a: reset1             |              | p                |
-     b: start_clearance    |              |                  |
-    -b: reset2             |          transcript validated   |
-     c: request_clearance  |              |                  |
-    -c: reset3             |              | q                |
-        (= reject request) |              |                  |
-     d: clear              |          transcript released    |
+                           |      +-- graduated              |
+                           |      |       |                  |
+                           |      |       | o                |
+                           |      |       |                  |
+                           |      |   transcript requested   |
+     a: admit              |      |       |                  |
+    -a: reset1             |    r |       | p                |
+     b: start_clearance    |      |       |                  |
+    -b: reset2             |      |   transcript validated   |
+     c: request_clearance  |      |       |                  |
+    -c: reset3             |      |       | q                |
+        (= reject request) |      |       |                  |
+     d: clear              |      +-- transcript released    |
     -d: N/A                +---------------------------------+
      e: N/A
@@ -87,4 +87,6 @@
      q: release_transcript
     -q: N/A
+     r: N/A
+    -r: reset11
 
 Student registration starts with the first login of the student into
@@ -135,4 +137,26 @@
 list.
 
+After graduation, former students (alumni) can apply for an official
+transcript. The transcript processing workflow (**opqr**) is a
+subset of the registration workflow which starts in state
+``graduated``. Many people are involved in transcript processing.
+Therefore, Kofa provides two additional roles, the Transcript
+Officer and Transcript Signee roles. Both are available globally and
+locally (at faculty level). First of all, the graduated student has
+to request a transcript **(o)** by filling a request form. The
+Transcript Officer will see the new request and can either reject
+the request **(-o)** or validate the request **(p)**. Before
+validation course results can be edited or added. After validation
+the entire studycourse including its content is locked. Nobody will
+be able to modify the course lists, neither through the UI nor by
+import. Transcripts can now be electronically signed by Transcript
+Signees. Once all signees have done their job, the Transcript
+Officer can release the transcript **(q)**. A pdf file is created
+and stored in the file system. The transcript pdf slip contains all
+signatures. The dynamic transcript generation is disabled. Nothing
+can be changed now, unless the entire transcript process is reset
+**(-r)** by a Students Manager. Then comments and signatures will be
+removed and the pdf file deleted. The student can start afresh.
+
 
 .. _registration_workflow_batch_processing:
Index: main/waeup.kofa/branches/henrik-transcript-workflow/src/waeup/kofa/permissions.py
===================================================================
--- main/waeup.kofa/branches/henrik-transcript-workflow/src/waeup/kofa/permissions.py	(revision 15151)
+++ main/waeup.kofa/branches/henrik-transcript-workflow/src/waeup/kofa/permissions.py	(revision 15152)
@@ -391,6 +391,6 @@
 
 class LocalTranscriptOfficer(grok.Role):
-    """The LocalTranscriptOfficer role can be assigned at faculty and
-    department level. The role allows to view, to validate and to
+    """The LocalTranscriptOfficer role can be assigned at faculty
+    level. The role allows to view, to validate and to
     release student transcripts.
     """
@@ -406,6 +406,6 @@
 
 class LocalTranscriptSignee(grok.Role):
-    """The LocalTranscriptSignee role can be assigned at faculty and
-    department level. The role allows to view and to sign student transcripts.
+    """The LocalTranscriptSignee role can be assigned at faculty
+    level. The role allows to view and to sign student transcripts.
     """
     grok.name('waeup.local.TranscriptSignee')